<?php
/**
 * Created by PhpStorm.
 * User: aisrael
 * Date: 2019-01-29
 * Time: 17:08
 */

namespace Drupal\xtcfile\XtendedContent\API;


use Drupal\xtc\XtendedContent\API\WriterBase;
use Drupal\xtc\XtendedContent\API\XtcLoaderHandler;
use Drupal\xtcfile\Plugin\XtcHandler\FileCreate;
use Symfony\Component\HttpFoundation\Response;

/**
 * Class XtcWriterFile
 *
 * @package Drupal\xtcfile\XtendedContent\API
 */
class WriterFile extends WriterBase
{

  /**
   * @param $content
   * @param $name
   * @param array $options
   *
   * @return mixed|\Symfony\Component\HttpFoundation\Response
   */
  public static function write($content, $name, $options = []){
    $handler = XtcLoaderHandler::getHandlerFromProfile($name, $options);
    if (!empty($handler) && ($handler instanceof FileCreate)) {
      $handler->writeContent($content);
      $path = $handler->getOptions()['path'] ?? '';
      if ($handler->size() > 0) {
        return New Response('file created / modified: ' . $path . '(' . $handler->size() . ')');
      }
      return New Response('file not created / modified: ' . $path);
    }
  }
}
